var canvas = document.getElementById('cube');
var camera, scene, renderer;
var geometry, material, mesh;

init();
animate();

function init() {

    camera = new THREE.PerspectiveCamera( 70, 200 / 200, 0.01, 10 );
    camera.position.z = 1;

    scene = new THREE.Scene();

    geometry = new THREE.BoxGeometry( 0.5, 0.5, 0.5 );
    material = new THREE.MeshNormalMaterial();

    mesh = new THREE.Mesh( geometry, material );
    scene.add( mesh );

    renderer = new THREE.WebGLRenderer( { antialias: true } );
    renderer.setSize( 200, 200 );
    document.getElementById("cube").appendChild(renderer.domElement);
}

function animate() {
	var element = document.getElementById('midi-data').textContent
	var extensionRemoved = element.split(",");
    requestAnimationFrame( animate );
    mesh.rotation.x = extensionRemoved[1];
    mesh.rotation.y = extensionRemoved[2];
	mesh.position.z = extensionRemoved[1] / 200.0;
    renderer.render( scene, camera );
}
