// it uses https://surikov.github.io/webaudiofont/ and the webmidi stuff is mainly from here https://webaudiodemos.appspot.com/midi-synth/index.html

var AudioContextFunc = window.AudioContext || window.webkitAudioContext;
var audioContext = new AudioContextFunc();
var player = new WebAudioFontPlayer();
var analyser = audioContext.createAnalyser();
analyser.fftSize = 2048;
var bufferLength = analyser.frequencyBinCount; 
var dataArray = new Uint8Array(bufferLength);
var envelope = null
var midiNotes = [];
var midiNotes2 = [];
var gainNode = audioContext.createGain();
        
function midNoteOn(pitch, velocity) {	
  midiNoteOff(pitch);
  envelope = player.queueWaveTable(audioContext, audioContext.destination, tone, 0, pitch, 123456789, velocity / 500);
  console.log("test")
  var note = {
  pitch: pitch,
  envelope: envelope
  }
  
  midiNotes.push(note);
  envelope.connect(analyser)
}

function midiNoteOff(pitch) {	
  for (var i = 0; i < midiNotes.length; i++) {
    if (midiNotes[i].pitch == pitch) {
      if (midiNotes[i].envelope) {
        midiNotes[i].envelope.cancel();
      }	  
	midiNotes.splice(i, 1);
	return;		
    }
  }
}

function midiNoteOn2(pitch, velocity) {
  var nn = player.loader.findDrum(pitch);
  var info = player.loader.drumInfo(nn)
  player.loader.startLoad(audioContext, info.url, info.variable);
  player.loader.waitLoad(function () {
  tone2=window[info.variable]; 
  midiNoteOff2(pitch);
  envelope = player.queueWaveTable(audioContext, audioContext.destination, tone2, 0, 48, 123456789, velocity / 500);
      var note = {
  pitch: pitch,
  envelope: envelope
  }
  midiNotes2.push(note);
  envelope.connect(analyser)
  gainNode.gain.value = 1.25;
        envelope.connect(gainNode);
        visualizer.connectAudio(gainNode);
		//startRenderer();
  });  
}

function midiNoteOff2(pitch) {
  for (var i = 0; i < midiNotes2.length; i++) {
    if (midiNotes2[i].pitch == pitch) {
      if (midiNotes2[i].envelope) {
        midiNotes2[i].envelope.cancel();
      }
	midiNotes2.splice(i, 1);
	return;
    }
  }
}

var sel = document.getElementById('ins');
for(var i = 0; i < player.loader.instrumentKeys().length; i++) {
  var opt = document.createElement('option');
  opt.innerHTML = ''+(i+1)+'. '+player.loader.instrumentInfo(i).title;
  if(i==12){
    opt.selected = 'selected'
  }
  sel.appendChild(opt);
  selectIns(this)
  }
  
function selectIns(o){
  var n=document.getElementById('ins').selectedIndex;
  var info=player.loader.instrumentInfo(n)
  player.loader.startLoad(audioContext, info.url, info.variable);
  player.loader.waitLoad(function () {
  tone=window[info.variable];
  player.cancelQueue(audioContext);
  });
}

function selectInsControl(n){	  
  var info=player.loader.instrumentInfo(n)
  player.loader.startLoad(audioContext, info.url, info.variable);
  player.loader.waitLoad(function () {
  tone=window[info.variable];
  player.cancelQueue(audioContext);
  });	  
  document.getElementById("ins").selectedIndex = n;
}
			
function midiMessageReceived( ev ) {
	
  const device = midiOut;
  device.send(ev.data); 
 
  var dataList = document.querySelector('#midi-data')
  var newItem = document.createElement('p');
  newItem.appendChild(document.createTextNode(ev.data));
  dataList.innerHTML = '';
  dataList.appendChild(newItem);
  console.log( "" + ev.data[0] + " " + ev.data[1] + " " + ev.data[2])

  var data = ev.data;
  var channel = data[0];
  var pitch = data[1];
  var velocity = data[2];
  if (channel == 144 && velocity > 0) {
    midNoteOn(pitch, velocity);
  }
  if (channel == 144 && velocity == 0) {
  midiNoteOff(pitch);
  }
  if (channel == 153 && velocity > 0 && pitch > 34 && pitch < 82) {	 
    midiNoteOn2(pitch , velocity);
  }
  if (channel == 153 && velocity == 0 && pitch > 34 && pitch < 82) {
    midiNoteOff2(pitch);
  }
  if ( channel == 192) {
    selectInsControl(data[1]);
  }
}

var inSelectMIDI = null;
var outSelectMIDI = null;
var midiAccess = null;
var midiIn = null;
var midiOut = null;

function selectMIDIIn( ev ) {
  if (midiIn)
    midiIn.onmidimessage = null;
  var id = ev.target[ev.target.selectedIndex].value;
  if ((typeof(midiAccess.inputs) == "function"))   //Old Skool MIDI inputs() code
    midiIn = midiAccess.inputs()[ev.target.selectedIndex];
  else
    midiIn = midiAccess.inputs.get(id);
  if (midiIn)
    midiIn.onmidimessage = midiMessageReceived;
}

function populateMIDIInSelect() {
  // clear the MIDI input select
  inSelectMIDI.options.length = 0;
  if (midiIn && midiIn.state=="disconnected")
    midiIn=null;
  var firstInput = null;
  var inputs=midiAccess.inputs.values();
  for ( var input = inputs.next(); input && !input.done; input = inputs.next()){
    input = input.value;
    if (!firstInput)
      firstInput=input;
    var str=input.name.toString();
    var preferred = !midiIn;
	
    // if we're rebuilding the list, but we already had this port open, reselect it.
    if (midiIn && midiIn==input)
      preferred = true;
    inSelectMIDI.appendChild(new Option(input.name,input.id,preferred,preferred));
    if (preferred) {
      midiIn = input;
      midiIn.onmidimessage = midiMessageReceived;
    }
  }
  if (!midiIn) {
      midiIn = firstInput;
      if (midiIn)
        midiIn.onmidimessage = midiMessageReceived;
  }
}

function midiConnectionStateChangeIn( e ) {
  console.log("connection in: " + e.port.name + " " + e.port.connection + " " + e.port.state );
  populateMIDIInSelect();
}

function onMIDIStartedIn( midi ) {
  var preferredIndex = 0;
  midiAccess = midi;
  document.getElementById("midiIn");
  inSelectMIDI=document.getElementById("midiIn");
  midi.onstatechange = midiConnectionStateChangeIn;
  populateMIDIInSelect();
  inSelectMIDI.onchange = selectMIDIIn; 
}

function selectMIDIOut( ev ) {
  if (midiOut)
    midiOut.onmidimessage = null;
  var id = ev.target[ev.target.selectedIndex].value;
  if ((typeof(midiAccess.outputs) == "function"))   //Old Skool MIDI inputs() code
    midiOut = midiAccess.outputs()[ev.target.selectedIndex];
  else
    midiOut = midiAccess.outputs.get(id);
  if (midiOut)
    midiOut.onmidimessage = midiMessageReceived;
}

function populateMIDIOutSelect() {
  // clear the MIDI input select
  outSelectMIDI.options.length = 0;
  if (midiOut && midiOut.state=="disconnected")
    midiOut=null;
  var firstOutput = null;
  var outputs=midiAccess.outputs.values();
  for ( var output = outputs.next(); output && !output.done; output = outputs.next()){
    output = output.value;
    if (!firstOutput)
      firstOutput=output;
    var str=output.name.toString();
    var preferred = !midiOut;

    // if we're rebuilding the list, but we already had this port open, reselect it.
    if (midiOut && midiOut==output)
      preferred = true;

    outSelectMIDI.appendChild(new Option(output.name,output.id,preferred,preferred));
    if (preferred) {
      midiOut = output;
      midiOut.onmidimessage = midiMessageReceived;
    }
  }
  if (!midiOut) {
      midiOut = firstOutput;
      if (midiOut)
        midiOut.onmidimessage = midiMessageReceived;
  }
}

function midiConnectionStateChangeOut( e ) {
  console.log("connection out: " + e.port.name + " " + e.port.connection + " " + e.port.state );
  populateMIDIOutSelect();
}

function onMIDIStartedOut( midi ) {
  var preferredIndex = 0;
  midiAccess = midi;
  document.getElementById("midiOut");
  outSelectMIDI=document.getElementById("midiOut");
  midi.onstatechange = midiConnectionStateChangeOut;
  populateMIDIOutSelect();
  outSelectMIDI.onchange = selectMIDIOut;
}

function onMIDISystemError( err ) {
  console.log( "MIDI not initialized - error encountered:" + err.code );
}
		
//init: start up MIDI
window.addEventListener('load', function() {   
  if (navigator.requestMIDIAccess)
    navigator.requestMIDIAccess().then( onMIDIStartedIn, onMIDISystemError );
	navigator.requestMIDIAccess().then( onMIDIStartedOut, onMIDISystemError );
});